#ifndef AiboBiff_h_DEFINED
#define AiboBiff_h_DEFINED

#include <OPENR/OObject.h>
#include <OPENR/OSubject.h>
#include <OPENR/OObserver.h>
#include "TCPConnection.h"
#include "AiboBiffConfig.h"
#include "def.h"

enum POP3State {
    POP3_CONNECTED,
    POP3_USER,
    POP3_PASS,
    POP3_STAT,
    POP3_QUIT,
    POP3_CLOSE
};

class AiboBiff: public OObject {
public:
    AiboBiff();
    virtual ~AiboBiff() {}

    OSubject*   subject[numOfSubject];
    OObserver*  observer[numOfObserver];     

    virtual OStatus DoInit   (const OSystemEvent& event);
    virtual OStatus DoStart  (const OSystemEvent& event);
    virtual OStatus DoStop   (const OSystemEvent& event);
    virtual OStatus DoDestroy(const OSystemEvent& event);

    void ConnectCont(void* msg);
    void SendCont   (void* msg);
    void ReceiveCont(void* msg);
    void CloseCont  (void* msg);

private:
    OStatus Connect(int index);
    OStatus Send   (int index);
    OStatus Receive(int index);
    OStatus Close  (int index);
    OStatus InitTCPConnection(int index);

    void SetSendData(int index);
    void SetReceiveData(int index);

    antStackRef    ipstackRef;
    TCPConnection  connection[AIBOBIFF_CONNECTION_MAX];
    
    void AiboBiff::CheckStat(char* resp);
    
    char serverip[40];
    int serverport;
    char username[40];
    char password[40];
    
    POP3State pop3state;
};

#endif // AiboBiff_h_DEFINED
